const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const quiz_tags = sequelize.define(
    'quiz_tags',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

tag_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"topic",


"mode_fit",


"skill",


"curriculum",


"event"

        ],

      },

is_featured: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  quiz_tags.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




















    db.quiz_tags.hasMany(db.quiz_tag_links, {
      as: 'quiz_tag_links_tag',
      foreignKey: {
          name: 'tagId',
      },
      constraints: false,
    });


















//end loop






    db.quiz_tags.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.quiz_tags.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return quiz_tags;
};


